<?PHP
#error_reporting(E_ALL);
header("Content-Type: text/html; charset=windows-1251");

$_GET = array();
$param = explode('/', $_SERVER['REQUEST_URI']);
if(isset($param[2]) and $param[2] != '') $_GET['unit'] = $param[2];
if(isset($param[3]) and $param[3] != '') $_GET['switch'] = $param[3];

$url = 'http://localhost/map/';
$community = 'public';
$unit = array(
    'servernaya1' => array(
        'router' => '10.10.10.1',
        'switch' => array('192.168.1.2'),
    ),
    'mashzal15' => array(
        'router' => '10.10.10.2',
        'switch' => array('192.168.2.2', '192.168.2.3'),
    ),
);

#   OID
$sysDescr          = '.1.3.6.1.2.1.1.1';            #  
$dot1dTpFdbAddress = '.1.3.6.1.2.1.17.4.3.1.1';     #  MAC   
$dot1dTpFdbPort    = '.1.3.6.1.2.1.17.4.3.1.2';     #   MAC    
$atPhysAddress     = '.1.3.6.1.2.1.3.1.1.2';        #   MAC  IP   

echo <<<HERE
<html>
    <head>
        <meta http-equiv="content-type" content="text/html; charset=windows-1251">
        <title>    </title>
        <style>
body, table, tr, td {
    font-style: normal;
    font-family: verdana, arial, helvetica, sans-serif;
    font-size: 11px;
}
body {
    background-color: #FFEBD5;
}
tr, td {
    padding: 2px;
}
#head {
    font-weight: bold;
    background-color: #9CB7D1;
    margin: 2px;
    border-radius: 2px;
}
td#head {
    color: black;
}
a:link, a:visited, a:active { 
    text-decoration: underline;
    color: white;
}
a:hover { 
    text-decoration: none;
    color: white;
}
#activ {
    color: #FFEBD5;
} 
#port {
    font-weight: bold;
    background-color: #9CB7D1;
    margin: 2px;
    border-radius: 2px;
}
#num {
    color: black;
}
td#title {
    background-color: #CED7DF;
    font-weight: bold;
    border-radius: 2px;
    color: black;
}
td#host1 {
    font-family: Courier New, monospace;
    font-weight: bold;
    background-color: #F2F7FA;
    border-radius: 2px;
    color: black;
}
td#host2 {
    font-family: Courier New, monospace;
    font-weight: bold;
    background-color: #E1E7EC;
    border-radius: 2px;
    color: black;
}
        </style>
    </head>
    <body>
<table width="100%" id="head">
   <tr>
      <td width="100%">
<table width="100%" id="head">
   <tr>
      <td width="122"> :</td>
      <td id="head">
HERE;
if(count($unit) > 0) {
    foreach($unit as $name => $info) $u[] = '<a href="'.$url.$name.'"'.((isset($_GET['unit']) and $_GET['unit'] == $name)?' id="activ"':'').'>'.$name.'</a>';
}
echo isset($u)? implode(' ', $u) : '  ';
echo <<<HERE
      </td>
   </tr>
   <tr>
      <td width="122"> :</td>
      <td id="head">
HERE;
if(count($unit[$_GET['unit']]['switch']) > 0 and isset($unit[$_GET['unit']])) {
    foreach($unit[$_GET['unit']]['switch'] as $id => $name) {
        $s[] = '<a href="'.$url.$_GET['unit'].'/'.$id.'"'.((isset($_GET['switch']) and $_GET['switch'] == $id)?' id="activ"':'').'>'.$name.'</a>';
    }
    echo isset($s)? implode(' ', $s) : '  ';
}
else {
    echo '  ';
}
echo <<<HERE
      </td>
   </tr>
</table>
      </td>
    </tr>
</table>
<table width="100%" id="head">
   <tr>
      <td width="100%">
<table width="100%" id="head">
   <tr>
      <td id="head">
HERE;
if(isset($_GET['unit'], $_GET['switch'], $unit[$_GET['unit']]['switch'][$_GET['switch']])) {
    $session = new SNMP(SNMP::VERSION_1, $unit[$_GET['unit']]['switch'][$_GET['switch']], $community); 
    $session->valueretrieval = SNMP_VALUE_LIBRARY;
    $session->oid_output_format = SNMP_OID_OUTPUT_NUMERIC;
    $session->oid_increasing_check = false;

    foreach($session->walk($sysDescr) as $id => $val) { 
        echo (($name = str_replace('STRING: ', ' ', $val)) != '""')? $name : '     ';
    }
    $session->close();
}
else echo '&nbsp;';
echo <<<HERE
      </td>
   </tr>
</table>
      </td>
   </tr>
</table>
HERE;

if(isset($_GET['unit'], $_GET['switch'], $unit[$_GET['unit']]['router'], $unit[$_GET['unit']]['switch'][$_GET['switch']])) {
    $mac = $port = $map = array(); 

    $session = new SNMP(SNMP::VERSION_1, $unit[$_GET['unit']]['router'], $community); 
    $session->valueretrieval = SNMP_VALUE_LIBRARY;
    $session->oid_output_format = SNMP_OID_OUTPUT_NUMERIC;
    $session->oid_increasing_check = false;

    $info = @$session->walk($atPhysAddress);
    if($session->getErrno() == 0 and count($info) > 0) {
        foreach($info as $id => $val) { 
            $id = str_replace($atPhysAddress.'.', '', $id); 
            $val = explode(': ', $val); 
            $val = trim($val[1]);
            # ,      ,  
            $r = explode('.', $id);
            unset($r[0], $r[1]);
            $id = implode('.', $r);
        
            $route[$val] = $id; 
        }
    }
    $session->close(); 
 
    $session = new SNMP(SNMP::VERSION_1, $unit[$_GET['unit']]['switch'][$_GET['switch']], $community);
    $session->valueretrieval = SNMP_VALUE_LIBRARY; 
    $session->oid_output_format = SNMP_OID_OUTPUT_NUMERIC;
    $session->oid_increasing_check = false;
    $info = @$session->walk($dot1dTpFdbPort);
    if($session->getErrno() == 0 and count($info) > 0) {
        foreach($info as $id => $val) { 
            $id = str_replace($dot1dTpFdbPort.'.', '', $id); 
            $val = explode(': ', $val); 
            $val = trim($val[1]);
            if($val != 0) $port[$id] = $val;
        }
    }
    $info = @$session->walk($dot1dTpFdbAddress);
    if($session->getErrno() == 0 and count($info) > 0) {
        foreach($info as $id => $val) { 
            $id = str_replace($dot1dTpFdbAddress.'.', '', $id); 
            $val = explode(': ', $val); 
            $val = trim($val[1]);
            $table[$id] = $val;
            if(isset($port[$id])) {
                $map[$port[$id]][] = array('MAC' => $val, 'IP' => (isset($route[$val])? $route[$val] : ''));
            }
        }
    }
    $session->close(); 
 
    if(isset($map) and count($map) > 0) {
        ksort($map);
        foreach($map as $port => $info) {
            $i = 1;
            echo '<table width="100%" id="port"><tr><td width="100%">';
            echo '<table width="100%"><tr><td colspan="3"><b id="num"> #'.$port.'</b></td></tr>';
            echo '<tr><td id="title" width="122">MAC</td><td id="title" width="122">IP</td><td id="title"></td></tr>';
            foreach($info as $num => $host) {
                $vendor = explode('(hex)', shell_exec("cat ./oui.txt | grep ".str_replace(' ', '-', substr($host['MAC'], 0, 8))));
                $vendor = isset($vendor[1])? trim($vendor[1]) : ''; 
                $css = ((($i++)%2!=0)?'1':'2');
                echo '<tr><td id="host'.$css.'" width="122">'.$host['MAC'].'</td><td id="host'.$css.'" width="122">'.$host['IP'].'</td><td id="host'.$css.'">'.$vendor.'</td></tr>'; 
            }
            echo '</table>';
            echo '</td></tr></table>';
        }
    }
    else {
        echo '<table width="100%" id="head"><tr><td width="100%"><table width="100%" id="head"><tr><td id="head">    MAC </td></tr></table></td></tr></table>';
    }
}
else {
    echo '<table width="100%" id="head"><tr><td width="100%"><table width="100%" id="head"><tr><td id="head">1.  <br>2.    </td></tr></table></td></tr></table>';
}
echo <<<HERE
    </body>
</html>
HERE;
?>